#include <stdio.h>
#include <string>

static void errorFileOpen(
		const string &fileName, const char *forWhat ){
	string message( "Cannot open file '" );
	message += fileName; message += "' for "; message += forWhat;
	throw message;
	}

int main( int argc, char *argv[] ){
 
    if( argc != 2 ){
        cout << "Usage: Mp3Decoder <filename.mp3>" << endl;
		printf( "Usage: dumpmp3 <file>.mp3\n" );
        exit(-1);
        }

    try {
    	const char *mp3FileName = argv[1];
		FILE *ifs = fopen( mp3FileName, "rb" );

		if( ifs == NULL )
			errorFileOpen( mp3FileName, "reading" );

		int readWord;

		while( (readWord=getc(ifs)) != EOF ){
			if( readWord >> 4 )
				printf( "%2X\n", readWord );
			else
				printf( "0%X\n", readWord );
			}

		fclose( ifs );
        }

    catch( string message ) {
        cerr << message << endl;
        cerr << "Fatal Error: Program aborting." << endl;
        return -1;
        }
    catch(...) {
        cerr << "Error: Unclassified exception." << endl;
        cerr << "Fatal Error: Program aborting." << endl;
        return -1;
        }
    return 0;
}
