///////////////////////////////////////////////////////////////////////////
// Filename : monitor_header.cpp
// Project  : MP3 Decoder
// Author   : GoodKook / goodkook@nms.anslab.co.kr
// Company  : AnsLab Co. / http://www.anslab.co.kr
// Revision :
// Comment  : Waveform Monitor
//

#include "monitor_header.h"

//////////////////////////////////////////////////////////////////////////
// Monitor
//
void monitor_header::proc_monitor()
{
//  t_clk                   = (bool)clk.read();
//  t_rst                   = (bool)rst.read();
    t_ready                 = (bool)ready.read();
    t_start                 = (bool)start.read();
    t_ch                    = (bool)ch.read();
    t_gr                    = (bool)gr.read();
    t_big_values            = big_values.read();
    t_block_type            = block_type.read();
    t_count1table_select    = (bool)count1table_select.read();
    t_global_gain           = global_gain.read();
    t_subblock_gain0        = subblock_gain0.read();
    t_subblock_gain1        = subblock_gain1.read();
    t_subblock_gain2        = subblock_gain2.read();
    t_mixed_block_flag      = (bool)mixed_block_flag.read();
    t_part2_3_length        = part2_3_length.read();
    t_preflag               = (bool)preflag.read();
    t_region0_count         = region0_count.read();
    t_region1_count         = region1_count.read();
    t_scalefac_compress     = scalefac_compress.read();
    t_scalefac_scale        = (bool)scalefac_scale.read();
    t_scfsi0                = (bool)scfsi0.read();
    t_scfsi1                = (bool)scfsi1.read();
    t_scfsi2                = (bool)scfsi2.read();
    t_scfsi3                = (bool)scfsi3.read();
    t_table_select0         = table_select0.read();
    t_table_select1         = table_select1.read();
    t_table_select2         = table_select2.read();
    t_window_switching_flag = (bool)window_switching_flag.read();
    t_stereo                = (bool)stereo.read();
    t_bitrate_index         = bitrate_index.read();
    t_mode                  = mode.read();
    t_mode_ext              = mode_ext.read();
    t_version               = (bool)version.read();
    t_sampling_frequency    = sampling_frequency.read();
}

void monitor_header::print_header()
{
    static int bitrate[2][16] = {
        { 0,  8, 16, 24, 32, 40, 48, 56,  64,  80,  96, 112, 128, 144, 160, 0 },    // MPEG-2
        { 0, 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 0 } };  // MPEG-1
    static double freq_sampling[2][4] = {
        { 22.05, 24, 16, 0 },   // MPEG-2
        { 44.1,  48, 32, 0 } }; // MPEG-1
    static char *str_mode_ext[4] = { "", "[Intensity]", "[MS]", "[Intensity-MS]" };
    static char *str_stereo[4]   = { "Stereo", "J-Stereo", "Dual Ch", "Single Ch" };

    if (ready.event() && ready)
    {
        cout << "MPEG-" << t_version << endl;
        cout << "Bitrate : " << bitrate[t_version][t_bitrate_index] << "Kbps" << endl;
        cout << "Sampling Frequency : " << freq_sampling[t_version][t_sampling_frequency] << "K" << endl;
        cout << "Mode(Stereo) : " << str_stereo[t_mode] << str_mode_ext[t_mode_ext] << endl;
    }
}
