///////////////////////////////////////////////////////////////////////////
// Filename : monitor_scale.h
// Project  : MP3 Decoder
// Author   : GoodKook / goodkook@nms.anslab.co.kr
// Company  : AnsLab Co. / http://www.anslab.co.kr
// Revision :
// Comment  :
//
//
#ifndef MONITOR_SCALEFACTOR_INC
#define MONITOR_SCALEFACTOR_INC

#include "systemc.h"

SC_MODULE(monitor_scale)
{
    sc_in<sc_bit>           preflag_out;
    sc_in<unsigned long>    part2_start;

    // Process ///////////////////////////////////////////////////////////
    void proc_scale();

    // Signals ///////////////////////////////////////////////////////////
    bool            t_preflag_out;

    // Waveform //////////////////////////////////////////////////////////////
    public:
        sc_trace_file*  tf;

    // Constructor ///////////////////////////////////////////////////////////
    SC_CTOR(monitor_scale)
    {
        SC_METHOD(proc_scale);
        sensitive
            << preflag_out;

        // Waaveform ///////////////////////////////
        tf = sc_create_vcd_trace_file("scale");
        ((vcd_trace_file*)tf)->sc_set_vcd_time_unit(-9);

        sc_trace(tf, part2_start,   "part2_start");
        sc_trace(tf, t_preflag_out, "preflag_out");
    }
};

#endif
